package org.ts.ddcs.DataItemTemplate;


import org.ts.ddcs.Entity.RtuStatusEntity;
import org.ts.ddcs.Tool.BytesHelp;
import org.ts.ddcs.Tool.StringUtil;


/**
 * funcode 0xFF55
 * 设备状态,1字节HEX	0 - SD   1 - FLASH
 */
@SuppressWarnings("all")
public class DataItemTemplateFF55 extends DataItemTemplate {


    @Override
    public byte[] Stream(byte[] data) {
        byte[] remain = data;
        if (this.macth) {
            return remain;
        }
        int count = 0;
        String flag = BytesHelp.byte2HexStr(remain, count, 2);
        count += 2;
        if (flag.equals(this.feture)) {
            byte[] len = BytesHelp.subBytes(remain, count, 1);
            count += 1;
            int dataTotalLen = len[0] >> 3;
            int decimalLen = len[0] & 7;
            byte[] buff = BytesHelp.subBytes(remain, count, dataTotalLen);
            String hexStr = BytesHelp.byte2HexStr(buff);
            StringBuffer dataStr = new StringBuffer(hexStr);
            if (decimalLen != 0) {
                dataStr.insert(dataStr.length() - decimalLen, ".");
            }
            count += dataTotalLen;
            String value = StringUtil.getPrettyNumber(dataStr.toString());
            this.varcharValue = value;
            remain = BytesHelp.subBytes(remain, count, remain.length - count);
            this.macth = true;
        }
        return remain;
    }

    @Override
    public void SetEntity(Object entity) {
        RtuStatusEntity statusEntity = (RtuStatusEntity) entity;
        byte[] buff = BytesHelp.hexStr2Bytes(this.varcharValue);
        statusEntity.setStatus((int)buff[0]);
    }

    @Override
    public String toString() {
        if (varcharValue.equals("0")) {
            return "SD卡正常";
        } else {
            return "SD卡损坏";
        }
    }
}
